Auto Multiple Choice - Bug # 520: Export CSV conflit ";" with "cases cochées = 0;0;1;0"
Description: Lorsqu'on exporte les résultats en CSV, on a l'option de choisir "inclure les cases cochées" et ce en deux
formats :
* ABD
*1;1;0;1
Cependant, lors de I'export vers CSV, ";" est déja le séparateur part défaut. Donc si on a deux questions a 5
choix on aurait par exemple :

* (encodage ABCD)

<pre>
Q1;TICKED:Q1;Q2:TICKED;Q2
2;:AB;7;:AC

</pre>

Une grille de 2 lignes et 4 colonnes comme attendu.

* (encodage 0;1;0;1)

<pre>
Q1;TICKED:Q1;Q2:TICKED;Q2
2;1;1;0;0;0;7;1;0;1;0;0

</pre>

Cela n'est pas vraiment un csv dans le format attendu, on a une grille de 2 lignes et 12 colonnes, avec des
cases vides.

* Une solution est donc d'utiliser "," comme séparateur :

<pre>
Q1,TICKED:Q1,Q2:TICKED,Q2
2,1,1;0;0;0,7,1;0;1;0;0

</pre>

Cela est déja possible dans l'interface graphique.
Cependant, cela peut clasher avec les "," du délimiteur décimal.

* Une autre solution serait de mettre les champs entre guillemets.

<pre>
Q1;TICKED:Q1;Q2:TICKED;Q2
2;"1,1;0;0;0";7;"1;0;1;0;0"
</pre>

* ou d'encoder 0;1;0;1 en 0101, ce qui est une mauvaise idée car pourrait étre confondu avec I'entier 101,
* ou d'utiliser autre chose que 0 et 1, comme TFTFF (pour True False). Cependant pour un non anglophone I3
convention serait étonnante.

Je fais remarquer que Microsoft Excel utilise "," comme séparateur avec guillemets quand nécessaire par
défaut, avoir donc par défaut ce choix serait naturel pour les utilisateurs de Microsoft Excel (la majorité des
utilisateurs ?).

En effet, les utilisateurs de OpenOffice choisiront plutét le format ods.

Je signale en passant que I'encodage AB se limite a 26 caracteres, je pense que AMC devrait refuser
d'exporter un projet dans ce format si le test a une question avec plus de 26 choix.

A la place de refuser d'exporter, il pourrait émettre un warning.

Ce cas est rare mais il nous est arrivé de I'avoir lorsque nous utilisons AMC a l'université.

Actuellement, il continue "dans les ascii" et aprés "dans les unicode" mais cela pourrait créer des problémes
d'encodage.

History

12/20/2017 08:42 pm - Robert Vanden Eynde

Une autre solution serait de choisir un autre séparateur que ";" pour les, comme underscore :
<pre>

Q1;TICKED:Q1;Q2:TICKED;Q2

2;1.1.0.0.0;7;1.0.1.00

</pre>

L'underscore est un bon choix car il est souvent utilisé pour séparer des mots sans utiliser un caractére invisible comme I'espace.

Cependant il n'est pas trop visible et la séparation est bien visible en format texte.

12/20/2017 08:45 pm - Robert Vanden Eynde
Ou d'utiliser un module perl spécialisé pour I'export CSV:

https://stackoverflow.com/questions/1444096/how-do-i-create-a-csv-file-using-perl

12/26/2017 11:40 pm - Alexis Bienveniie
- Status changed from New to Closed

- Target version set to 1.4.0

- % Done changed from 0 to 100

Avec la révision commit:a86592de174e, les valeurs sont entourées de guillemets.

Avec la révision commit:a25811946b1a, on peut utiliser plus de 26 réponses dans une question. Les 26 premiéres réponses sont nommées A...Z, les
26 suivantes sont nommées Aa...Az, puis Ba...Bz, etc.
